package org.pathwaycommons.trans;

import org.genemania.dw.util.GenUtil;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.TreeMap;
import java.util.HashMap;

/**
 * Created by
 * User: risserlin
 * Date: Sep 27, 2010
 * Time: 5:38:07 PM
 */
public class MissingPMIDsFile {

    private HashMap<String, String> PMIDMap;
    private String missingPMIDsFileName;

    public MissingPMIDsFile(String missingPMIDsFileName){
         this.PMIDMap = new HashMap <String, String> ();

         this.missingPMIDsFileName = missingPMIDsFileName;
    }

    public void loadMissingPMIDsFile () {

        GenUtil.validateString(missingPMIDsFileName);

        try {
            BufferedReader br = new BufferedReader
                                    (new FileReader (missingPMIDsFileName));
            String line;
            while ((line = br.readLine ()) != null) {
                String tempArr [] = line.split (GenUtil.TAB);
                if(tempArr.length >= 2){
                	if (PMIDMap.containsKey(tempArr[0])) {
                    		System.err.println ("Error: non unique source term: " +
                                        tempArr[0]);
                	} //overwrite, anyway.
                	PMIDMap.put(tempArr[0], tempArr[1]);
                	//System.out.println (mapEntry.toString ());
		}
            }
            System.out.println ("Done reading CV Mapping from file: " + missingPMIDsFileName);
        } catch (IOException ioe) {
            ioe.printStackTrace ();
            System.err.println ("Unable to load mapping CVs from file: " +
                                 missingPMIDsFileName);
        }
    }

    public HashMap<String, String> getPMIDMap() {
        return PMIDMap;
    }
}
