package org.pathwaycommons.trans.util;

/**
 * Created by
 * User: risserlin
 * Date: Nov 23, 2010
 * Time: 3:57:52 PM
 */
public class GI_information {

    private Integer GI;

    private Integer taxid;

    //the State of the GI - LIVE, LIVE|Suppressed, Replaced
    public static String state_live = "LIVE";
    public static String state_sup = "LIVE|SUPPRESSED";
    public static String state_rep = "REPLACED";

    private String state;
    //latest GI
    private Integer updated_gi;
    //updated_date latest GI was assigned
    private String updated_date;
    //database of the accession
    private String db;
    //accession for the GI
    private String accession;

    //Given tokensize string construct a GI_information object
    public GI_information(String[] tokens){
        //some of the records could just be missing accessions
        if(tokens.length >= 5){
            this.GI = Integer.parseInt(tokens[0]);
            this.taxid =  Integer.parseInt(tokens[1]);
            this.state = tokens[2];
            this.updated_gi = Integer.parseInt(tokens[3]);
            this.updated_date = tokens[4];

        }

        //make sure there are enough tokens in the set
        else if(tokens.length != 7){
            System.out.println("There is not enough information for the GI:\t" + tokens[0]);
            return;
        }

        if(tokens.length >= 6){
            this.db = tokens[5];
            if(tokens.length > 6)
                this.accession = tokens[6];
            else
                System.out.println("There is no accession information for GI:\t" + tokens[0] + "\t Updated GI\t" + tokens[3]);
        }
        else{
            System.out.println("There is no accession information for GI:\t" + tokens[0] + "\t Updated GI\t" + tokens[3]);
        }
    }

    public GI_information(Integer GI, Integer taxid, String state, Integer updated_gi, String date, String db, String accession) {
        this.GI = GI;
        this.taxid = taxid;
        this.state = state;
        this.updated_gi = updated_gi;
        this.updated_date = date;
        this.db = db;
        this.accession = accession;
    }

    public Integer getGI() {
        return GI;
    }

    public void setGI(Integer GI) {
        this.GI = GI;
    }

    public String getState() {
        return state;
    }

    public void setState(String state) {
        this.state = state;
    }

    public Integer getUpdated_gi() {
        return updated_gi;
    }

    public void setUpdated_gi(Integer updated_gi) {
        this.updated_gi = updated_gi;
    }

    public String getUpdated_date() {
        return updated_date;
    }

    public void setUpdated_date(String updated_date) {
        this.updated_date = updated_date;
    }

    public String getDb() {
        return db;
    }

    public void setDb(String db) {
        this.db = db;
    }

    public String getAccession() {
        return accession;
    }

    public void setAccession(String accession) {
        this.accession = accession;
    }

    public Integer getTaxid() {
        return taxid;
    }

    public void setTaxid(Integer taxid) {
        this.taxid = taxid;
    }
}
