package org.pathwaycommons.trans.util;

import org.genemania.dw.util.GenUtil;

import java.util.HashMap;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 * Created by
 * User: risserlin
 * Date: Dec 6, 2010
 * Time: 11:23:33 AM
 */
public class LoadGIInformation {

    private HashMap<Integer, GI_information> gi_history;

    private String filename;

    public LoadGIInformation(String filename) {
        this.gi_history = new HashMap<Integer, GI_information>();
        this.filename = filename;
    }

    public HashMap<Integer, GI_information> load(){
        GenUtil.validateString(filename);

        try {
            BufferedReader br = new BufferedReader
                                    (new FileReader (filename));
            String line;
            while ((line = br.readLine ()) != null) {
                String tempArr [] = line.split (GenUtil.TAB);
                GI_information info = new GI_information(tempArr);

                if(info.getGI() != null)
                  gi_history.put(Integer.parseInt(tempArr[0]), info);
          }
            System.out.println ("Done reading GI history mappings from: " + filename);
        } catch (IOException ioe) {
            ioe.printStackTrace ();
            System.err.println ("Unable to load GI history mappings: " +
                                 filename);
        }
        return gi_history;
    }

}
